from OpenGL.GL import *
from OpenGL.GLU import *
from pygame.locals import *
import pygame
from vector import Vector
from math import pi

def main(width, height, tex):
    glDisable(GL_DEPTH_TEST)
    glDisable(GL_LIGHTING)
    glColor4f(1, 1, 1, 0.5)
    glEnable(GL_BLEND)
    glEnable(GL_TEXTURE_2D)
    position = 0.9
    clock = pygame.time.Clock()
    done = False
    #
    # Show about marquee
    #
    points = [[(-1, -0.7, i/2.0), (1, -0.7, i/2.0)] for i in range(24)]
    while not done and tex['about'].texid != 0:
        # Blank screen
        glClear(GL_COLOR_BUFFER_BIT)
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()
        glMatrixMode(GL_MODELVIEW)
        glLoadIdentity()
        # Starry background
        glBlendFunc (GL_SRC_ALPHA, GL_ONE)
        glColor4f(1, 1, 1, 1)
        glBindTexture (GL_TEXTURE_2D, tex['menubg'].texid)
        glBegin(GL_QUADS)
        glTexCoord2f(0, 0)
        glVertex3f(-1.2, 1, 0)
        glTexCoord2f(0, 1)
        glVertex3f(1.2, 1, 0)
        glTexCoord2f(1, 1)
        glVertex3f(1.2, -2.2, 0)
        glTexCoord2f(1, 0)
        glVertex3f(-1.2, -2.2, 0)
        glEnd()
        # About marquee
        glBlendFunc (GL_SRC_ALPHA, GL_ONE)
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()
        gluPerspective(45, width/height, 0.1, 40.0)
        glMatrixMode(GL_MODELVIEW)
        glLoadIdentity()
        gluLookAt (0, 0, 0, 0, -.3, 1, 0, 1, 0)
        glColor4f(1, 1, 1, 0.8)
        glBindTexture (GL_TEXTURE_2D, tex['about'].texid)
        glBegin(GL_QUAD_STRIP)
        pos = position
        for p in points:
            glColor4f(1, 1, 1, 1-(p[0][2]/10.0))
            glTexCoord2f(1, pos)
            glVertex3fv(p[0])
            glTexCoord2f(0, pos)
            glVertex3fv(p[1])
            pos = min (pos + 0.035, 1)
        glEnd()
        pygame.display.flip()
        position -= 0.0003
        clock.tick(60)
        event = pygame.event.poll()
        while event.type != NOEVENT:
            if event.type == KEYDOWN:
                if event.key == K_ESCAPE or event.key == K_RETURN or event.key == K_SPACE:
                    done = True
            event = pygame.event.poll()
