'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "lib"
directory.
'''
import pygame
from pygame.locals import *
try:
    from OpenGL.GL import *
    from OpenGL.GLU import *
except:
    print 'This game requires PyOpenGL'
    raise SystemExit

import data
import intro
from menu import MainMenu
from texloader import LoadGLTextures
import effects

def main():
    #initialize pygame and setup an opengl display
    pygame.init()
    width = 640.0
    height = 480.0
    pygame.display.set_mode((width, height), OPENGL|DOUBLEBUF)
    tex = LoadGLTextures ({'logo': "logo.bmp",
                            'marquee': "marquee.bmp",
                            'skip': "escape_to_skip.bmp",
                            'menubg': "menubg.bmp",
                            'fonts': "fonts.bmp",
                            'about': "about.bmp",
                            'thumbnails': "thumbnails.bmp"})
    menu = MainMenu(tex)
    effects.loadConfig()

    intro.main(width, height, tex)
    menu.run(width, height)
