import pygame
from pygame.locals import *

from OpenGL.GL import *
from OpenGL.GLU import *


class Score(object):
    def __init__(self, value, pos, section):
        self.value = value
        self.sec = section
        self.pos = pos + (self.sec.up*0.1)
        self.ttl = 60
    def draw(self, world):
        glDepthMask(GL_FALSE)
        glDisable(GL_LIGHTING)
        glEnable(GL_BLEND)
        glBlendFunc(GL_SRC_COLOR, GL_ONE)
        glDisable(GL_DEPTH_TEST)
        glMatrixMode(GL_MODELVIEW)
        glPushMatrix()
        glTranslatef(*self.pos.coords())
        m = list((-self.sec.right).coords()) + [0] + list((-self.sec.up).coords()) + [0] + list(self.sec.forward.coords()) + [0, 0, 0, 0, 1]
        glMultMatrixf(m)
        world.drawScore(0, 0, 0, 0.1, 0.5, self.value)
        glPopMatrix()
        glEnable(GL_DEPTH_TEST)
        glDepthMask(GL_TRUE)
        glEnable(GL_LIGHTING)
        glDisable(GL_BLEND)
        self.pos += self.sec.up * 0.004
        self.ttl -=1
        return self.ttl < 0
