from OpenGL.GL import *
from OpenGL.GLU import *
from data import filepath
import pygame

class GameTexture:
    def __init__(self, name, texid):
        self.name = name
        self.texid = texid

def LoadGLTextures(filenames):
    """ Loads and configures textures.  Receives a dictionary with one key per
        texture to load, (key->filename) and returns a dictionary with one
        key per texture loaded (key->textureid) """
    texids = glGenTextures(len(filenames))
    textures = {'invalid':GameTexture('invalid',0)}
    i = 0
    for k in filenames.keys():
        poo = pygame.image.load(filepath(filenames[k]))
        sizeX = poo.get_width()
        sizeY = poo.get_height()
        data = pygame.image.tostring(poo, "RGBX", True)
        texid = len(filenames) == 1 and texids or texids[i]
        # Cast texid to int due to a bugreport on python 2.4.4 from lucas caro.  Check before changing!
        glBindTexture(GL_TEXTURE_2D, int(texid))    # 2d texture (x and y size)
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)  # scale linearly when image bigger than texture
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR)  # scale linearly when image smalled than texture
        try:
            glTexImage2D(GL_TEXTURE_2D, 0, 4, sizeX, sizeY, 0, GL_RGBA, GL_UNSIGNED_BYTE, data);
        except GLerror:
            # Unable to create texture!
            #glDeleteTextures([texid])
            print "In catch!"
            texid = 0
        textures[k] = GameTexture(k, int(texid))
        i += 1
    return textures

def LoadGLTexturesAlpha(filenames):
    """ Loads and configures textures.  Receives a dictionary with one key per
        texture to load, (key->filename) and returns a dictionary with one
        key per texture loaded (key->textureid) """
    texids = glGenTextures(len(filenames))
    textures = {'invalid':GameTexture('invalid',0)}
    i = 0
    for k in filenames.keys():
        poo = pygame.image.load(filepath(filenames[k]))
        sizeX = poo.get_width()
        sizeY = poo.get_height()
        data = pygame.image.tostring(poo, "RGBA")
        texid = len(filenames) == 1 and texids or texids[i]
        # Cast texid to int due to a bugreport on python 2.4.4 from lucas caro.  Check before changing!
        glBindTexture(GL_TEXTURE_2D, int(texid))    # 2d texture (x and y size)
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)  # scale linearly when image bigger than texture
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR)  # scale linearly when image smalled than texture
        glTexImage2D(GL_TEXTURE_2D, 0, 4, sizeX, sizeY, 0, GL_RGBA, GL_UNSIGNED_BYTE, data);
        textures[k] = GameTexture(k, int(texid))
        i += 1
    return textures

